;
;==================================
;===                            ===
;===   dynamic link RTR         ===
;===    mar. 15 '07  by@        ===
;===                            ===
;==================================
;*
;* feb. 22 '05
;* Apr.  8 '08 ... Ԃ낦
;* July 13 '08 ... LCD,KB ǉ
;* july 16 '08 ... for command
;*
rtrjt	equ	h'0ffd10	; for h8/3052
;
;=================================
;==                             ==
;==  jump table                 ==
;==                             ==
;=================================
;
\kbd		equ	h'00200
\con		equ	\kbd	+8
\con0		equ	\con	+8
\con1		equ	\con0	+8
\aux		equ	\con1	+8
\aux0		equ	\aux	+8
\aux1		equ	\aux0	+8
\lst		equ	\aux1	+8
\lst0		equ	\lst	+8
\lst1		equ	\lst0	+8
;
;===============================
;==                           ==
;==  halt                     ==
;==                           ==
;===============================
;
\halt:	nop
	rts
;
;===============================
;==                           ==
;==  initialize jmp tbl       ==
;==                           ==
;===============================
;
\lnkfre:mov.l	#128,r1
	mov.l	$10,r0
	mov.l	#rtrjt,r2
$1:	mov.l	r0,@r2
	add.l	#4,r2
	dec.w	#1,r1
	bne	$1
	rts
$10:	jsr	mdfyjt
;
;===============================
;==                           ==
;==  modify jmp tbl           ==
;==                           ==
;===============================
;
; name table get
;
vect2	equ	h'000008	; vect[2]
mdfyjt:	mov.l	r0,@-sp
	mov.l	r1,@-sp
	mov.l	r2,@-sp
	mov.l	r3,@-sp
	mov.l	r4,@-sp
	mov.l	r5,@-sp
;
; ret addr get
;
	mov.l	@(24,sp),r1	; ret addr
	sub.l	#4,r1		; table addr
	mov.l	r1,@(24,sp)
	sub.l	#rtrjt,r1
	mov.l	r1,r0
	add.l	r1,r1		; 2*4
	add.l	r0,r1		; 3*4
	add.l	#\namelist,r1
;
; terget addr request
; modify jmp table
;
	mov.l	r1,@-sp
	mov.l	vect2,r1	; getent addr
	jsr	@r1
	add.l	#h'5a000000,r0	; jmp
	mov.l	@(24,sp),r1	; ret addr
	mov.l	r0,@r1		; modfy tbl
;
; jmp to terget
;
	mov.l	@sp+,r5
	mov.l	@sp+,r4
	mov.l	@sp+,r3
	mov.l	@sp+,r2
	mov.l	@sp+,r1
	mov.l	@sp+,r0		; recover
	rts
;
;===============================
;==                           ==
;==  rtr name                 ==
;==                           ==
;===============================
;
	org	($+15)/16*16
\namelist:	db	 4,'addc       '
\addc		equ	rtrjt+4*0
		db	 4,'adds       '
\adds		equ	rtrjt+4*1
		db	 5,'addsi      '
\addsi		equ	rtrjt+4*2
		db	 5,'addss      '
\addss		equ	rtrjt+4*3
		db	 6,'adjlng     '
\adjlng		equ	rtrjt+4*4
		db	 4,'apdc       '
\apdc		equ	rtrjt+4*5
		db	 5,'apdsi      '
\apdsi		equ	rtrjt+4*6
		db	 4,'copy       '
\copy		equ	rtrjt+4*7
		db	 4,'crlf       '
\crlf		equ	rtrjt+4*8
		db	 6,'delete     '
\delete		equ	rtrjt+4*9
		db	 3,'div        '
\div		equ	rtrjt+4*10
		db	 3,'ich        '
\ich		equ	rtrjt+4*11
		db	 5,'ldsil      '
\ldsil		equ	rtrjt+4*12
		db	 4,'lodc       '
\lodc		equ	rtrjt+4*13
		db	 4,'lods       '
\lods		equ	rtrjt+4*14
		db	 5,'lodsi      '
\lodsi		equ	rtrjt+4*15
		db	 5,'lodsl      '
\lodsl		equ	rtrjt+4*16
		db	 3,'mod        '
\mod		equ	rtrjt+4*17
		db	 4,'movs       '
\movs		equ	rtrjt+4*18
		db	 5,'movsi      '
\movsi		equ	rtrjt+4*19
		db	 3,'mul        '
\mul		equ	rtrjt+4*20
		db	 3,'pos        '
\pos		equ	rtrjt+4*21
		db	 6,'readln     '
\readln		equ	rtrjt+4*22
		db	 6,'rlnlst     '
\rlnlst		equ	rtrjt+4*23
		db	 5,'saves      '
\saves		equ	rtrjt+4*24
		db	 5,'slset      '
\slset		equ	rtrjt+4*25
		db	 5,'sqrtl      '
\sqrtl		equ	rtrjt+4*26
		db	 3,'str        '
\str		equ	rtrjt+4*27
		db	 3,'tch        '
\tch		equ	rtrjt+4*28
		db	 6,'upcase     '
\upcase		equ	rtrjt+4*29
		db	 3,'val        '
\val		equ	rtrjt+4*30
		db	 6,'writes     '
\writes		equ	rtrjt+4*31
		db	 6,'wrtlnc     '
\wrtlnc		equ	rtrjt+4*32
		db	 6,'wrtlns     '
\wrtlns		equ	rtrjt+4*33
		db	 6,'xcmpys     '
xcmpys		equ	rtrjt+4*34
		db	 5,'xeqys      '
\xeqys		equ	rtrjt+4*35
		db	 5,'xgeys      '
\xgeys		equ	rtrjt+4*36
		db	 5,'xgtys      '
\xgtys		equ	rtrjt+4*37
		db	 5,'xleys      '
\xleys		equ	rtrjt+4*38
		db	 5,'xltys      '
\xltys		equ	rtrjt+4*39
		db	 5,'xneys      '
\xneys		equ	rtrjt+4*40
;
;-----------------------------------
;  DOS
;-----------------------------------
		db	 6,'append     '
\APPEND		equ	rtrjt+4*41
		db	 6,'assign     '
\ASSIGN		equ	rtrjt+4*42
		db	 5,'close      '
\CLOSE		equ	rtrjt+4*43
		db	 3,'eof        '
\EOF		equ	rtrjt+4*44
		db	 5,'erase      '
\ERASE		equ	rtrjt+4*45
		db	 8,'filesize   '
\FILESIZE	equ	rtrjt+4*46
		db	 9,'findfirst  '
\FINDFIRST	equ	rtrjt+4*47
		db	 8,'findnext   '
\FINDNEXT	equ	rtrjt+4*48
		db	 5,'mkdir      '
\MKDIR		equ	rtrjt+4*49
		db	 6,'rename     '
\RENAME		equ	rtrjt+4*50
		db	 5,'reset      '
\RESET		equ	rtrjt+4*51
		db	 7,'rewrite    '
\REWRITE	equ	rtrjt+4*52
		db	 5,'rmdir      '
\RMDIR		equ	rtrjt+4*53
		db	 8,'diskfree   '
\DISKFREE	equ	rtrjt+4*54
		db	 8,'getftime   '
\GETFTIME	equ	rtrjt+4*55
		db	 8,'setftime   '
\SETFTIME	equ	rtrjt+4*56
		db	 5,'chdir      '
\CHDIR		equ	rtrjt+4*57
		db	 9,'blockread  '
\BLOCKREAD	equ	rtrjt+4*58
		db	10,'blockwrite '
\BLOCKWRITE	equ	rtrjt+4*59
		db	 8,'filecopy   '
FILECOPY	equ	rtrjt+4*60
		db	 8,'filemove   '
FILEMOVE	equ	rtrjt+4*61
		db	11,'read_sector'
READ_SECTOR	equ	rtrjt+4*62
		db	11,'write_secto'
WRITE_SECTOR	equ	rtrjt+4*63
		db	 6,'dosini     '
DOSINI		equ	rtrjt+4*64
		db	 7,'validfd    '
VALIDFD		equ	rtrjt+4*65
		db	 7,'cformat    '
CFORMAT		equ	rtrjt+4*66
		db	10,'get_fndtbl '
GET_FNDTBL	equ	rtrjt+4*67
		db	 7,'sectsiz    '
SECTSIZ		equ	rtrjt+4*68
		db	10,'selectdisk '
SELECTDISK	equ	rtrjt+4*69
		db	 7,'getpath    '
GETPATH		equ	rtrjt+4*70
		db	 4,'exec       '
EXEC		equ	rtrjt+4*71
		db	10,'clust2sect '
clust2sect	equ	rtrjt+4*72
		db	11,'get_sectseq'
get_sectseq	equ	rtrjt+4*73
;
;-----------------------------------
;  LCD & key
;-----------------------------------
		db	 6,'lcdini     '
lcdini		equ	rtrjt+4*74
		db	 5,'gotox      '
gotox		equ	rtrjt+4*75
		db	 6,'lcdcmd     '
lcdcmd		equ	rtrjt+4*76
		db	 6,'keyini     '
keyini		equ	rtrjt+4*77
		db	 8,'oncursor   '
oncursor	equ	rtrjt+4*78
		db	 9,'offcursor  '
offcursor	equ	rtrjt+4*79
;
;-----------------------------------
;  clock
;-----------------------------------
		db	 6,'getclk     '
getclk		equ	rtrjt+4*80
		db	 6,'putclk     '
putclk		equ	rtrjt+4*81
		db	 7,'getdate    '
getdate		equ	rtrjt+4*82
		db	 7,'gettime    '
gettime		equ	rtrjt+4*83
		db	 7,'setdate    '
setdate		equ	rtrjt+4*84
		db	 7,'settime    '
settime		equ	rtrjt+4*85
;
;-----------------------------------
;  AUX
;-----------------------------------
		db	 7,'sci1ini    '
sci1ini		equ	rtrjt+4*86
		db	 9,'flushaux1  '
flushaux1	equ	rtrjt+4*87
;
;-----------------------------------
;  MTOS
;-----------------------------------
		db	 4,'wait       '
wait		equ	rtrjt+4*88
		db	 3,'pop        '
pop		equ	rtrjt+4*89
		db	 3,'vop        '
vop		equ	rtrjt+4*90
		db	 7,'taskrun    '
taskrun		equ	rtrjt+4*91
;
	end