;
;==================================
;===                            ===
;===   dynamic link RTR         ===
;===    mar. 15 '07  by@        ===
;===                            ===
;==================================
;*
;* dec.29 '08 ... ini.out  ini.inp ǉ
;* Jan. 5 '08 ... RAMł̃[`Ƃ
;*
vect2	equ	8
;
;===============================
;==                           ==
;==  initialize jmp tbl       ==
;==                           ==
;===============================
;
\lnkfre:bsr	devini
	bsr	usrini	; user device
	rts
;
;===============================
;==                           ==
;==  user device initialize   ==
;==                           ==
;===============================
;
usrini:	nop
	rts
;
;===============================
;==                           ==
;==  device table initialize  ==
;==                           ==
;===============================
;
devini:	mov.l	r0,@-sp
	mov.l	r1,@-sp
	mov.l	r2,@-sp
	mov.l	r3,@-sp
	mov.l	r4,@-sp
	mov.l	r5,@-sp
;
; search device set
;
	mov.l	vect2,r5
	mov.l	#\con-16,r4
	bra	$3
;
; search
;
$1:	lea	@(8,r4),r0	; string addr
	mov.l	r0,@-sp
	jsr	@r5		; search dev.
;
; if r0.l=0 (not found) --> r0.l=\con
;
	mov.l	#\con,r2
	and.l	r0,r0
	beq	$2
	mov.l	r0,r2
;
; save to dev table
;
$2:	mov.l	@r2,r1		; actual dev.
	mov.l	r1,@r4		; out rou.
	mov.l	@(4,r2),r1
	mov.l	r1,@(4,r4)	; inp rou.
;
; next table
;
$3:	add.l	#16,r4		; get dev.addr
	mov.l	@r4,r0
	cmp.l	#-1,r0
	bne	$1		; next
;
; owari
;
	mov.l	@sp+,r5
	mov.l	@sp+,r4
	mov.l	@sp+,r3
	mov.l	@sp+,r2
	mov.l	@sp+,r1
	mov.l	@sp+,r0
	rts
;
;===============================
;==                           ==
;==  modify jmp tbl           ==
;==                           ==
;===============================
;
; name table get
;
mdfyjt:	mov.l	r0,@-sp
	mov.l	r1,@-sp
	mov.l	r2,@-sp
	mov.l	r3,@-sp
	mov.l	r4,@-sp
	mov.l	r5,@-sp
;
; terget addr request
; modify jmp table
;
	mov.l	@(24,sp),r1	; STRING addr
	mov.l	r1,@-sp
	mov.l	vect2,r0	; getent addr
	jsr	@r0		; ret R0.L (addr)
	add.l	#h'5a000000,r0	; jmp
	mov.l	@(24,sp),r1	; ret addr
	sub.l	#4,r1
	mov.l	r1,@(24,sp)	; modfy ret addr
	mov.l	r0,@r1		; modfy tbl
;
; jmp to terget
;
	mov.l	@sp+,r5
	mov.l	@sp+,r4
	mov.l	@sp+,r3
	mov.l	@sp+,r2
	mov.l	@sp+,r1
	mov.l	@sp+,r0		; recover
	rts
;
;===============================
;==                           ==
;==  device table             ==
;==                           ==
;===============================
;
	org	($+15)/16*16
\con:	dl	0,0		; io.out io.in
	db	4,'\con   '
\con0:	dl	0,0
	db	5,'\con0  '
\con1:	dl	0,0
	db	5,'\con1  '
\aux:	dl	0,0
	db	4,'\aux   '
\aux0:	dl	0,0
	db	5,'\aux0  '
\aux1:	dl	0,0
	db	5,'\aux1  '
\lst:	dl	0,0
	db	4,'\lst   '
\lst0:	dl	0,0
	db	5,'\lst0  '
\lst1:	dl	0,0
	db	5,'\lst1  '
\kbd:	dl	0,0
	db	4,'\kbd   '
	dl	-1		; end mark
;
;===============================
;==                           ==
;==  rtr name                 ==
;==                           ==
;===============================
;
	org	($+15)/16*16
\addc:		jsr	mdfyjt
		db	 4,'addc       '
\adds:		jsr	mdfyjt
		db	 4,'adds       '
\addsi:		jsr	mdfyjt
		db	 5,'addsi      '
\addss:		jsr	mdfyjt
		db	 5,'addss      '
\adjlng:	jsr	mdfyjt
		db	 6,'adjlng     '
\apdc:		jsr	mdfyjt
		db	 4,'apdc       '
\apdsi:		jsr	mdfyjt
		db	 5,'apdsi      '
\copy:		jsr	mdfyjt
		db	 4,'copy       '
\crlf:		jsr	mdfyjt
		db	 4,'crlf       '
\delete:	jsr	mdfyjt
		db	 6,'delete     '
\div:		jsr	mdfyjt
		db	 3,'div        '
\halt:		jsr	mdfyjt
		db	 4,'halt       '
\ich:		jsr	mdfyjt
		db	 3,'ich        '
\ldsil:		jsr	mdfyjt
		db	 5,'ldsil      '
\lodc:		jsr	mdfyjt
		db	 4,'lodc       '
\lods:		jsr	mdfyjt
		db	 4,'lods       '
\lodsi:		jsr	mdfyjt
		db	 5,'lodsi      '
\lodsl:		jsr	mdfyjt
		db	 5,'lodsl      '
\mod:		jsr	mdfyjt
		db	 3,'mod        '
\movs:		jsr	mdfyjt
		db	 4,'movs       '
\movsi:		jsr	mdfyjt
		db	 5,'movsi      '
\mul:		jsr	mdfyjt
		db	 3,'mul        '
\pos:		jsr	mdfyjt
		db	 3,'pos        '
\readln:	jsr	mdfyjt
		db	 6,'readln     '
\rlnlst:	jsr	mdfyjt
		db	 6,'rlnlst     '
\saves:		jsr	mdfyjt
		db	 5,'saves      '
\slset:		jsr	mdfyjt
		db	 5,'slset      '
\sqrtl:		jsr	mdfyjt
		db	 5,'sqrtl      '
\str:		jsr	mdfyjt
		db	 3,'str        '
\tch:		jsr	mdfyjt
		db	 3,'tch        '
\upcase:	jsr	mdfyjt
		db	 6,'upcase     '
\val:		jsr	mdfyjt
		db	 3,'val        '
\writes:	jsr	mdfyjt
		db	 6,'writes     '
\wrtlnc:	jsr	mdfyjt
		db	 6,'wrtlnc     '
\wrtlns:	jsr	mdfyjt
		db	 6,'wrtlns     '
xcmyps:		jsr	mdfyjt
		db	 6,'xcmpys     '
\xeqys:		jsr	mdfyjt
		db	 5,'xeqys      '
\xgeys:		jsr	mdfyjt
		db	 5,'xgeys      '
\xgtys:		jsr	mdfyjt
		db	 5,'xgtys      '
\xleys:		jsr	mdfyjt
		db	 5,'xleys      '
\xltys:		jsr	mdfyjt
		db	 5,'xltys      '
\xneys:		jsr	mdfyjt
		db	 5,'xneys      '
;
;-----------------------------------
;  DOS
;-----------------------------------
\APPEND:	jsr	mdfyjt
		db	 6,'append     '
\ASSIGN:	jsr	mdfyjt
		db	 6,'assign     '
\CLOSE:		jsr	mdfyjt
		db	 5,'close      '
\EOF:		jsr	mdfyjt
		db	 3,'eof        '
\ERASE:		jsr	mdfyjt
		db	 5,'erase      '
\FILESIZE:	jsr	mdfyjt
		db	 8,'filesize   '
\FINDFIRST:	jsr	mdfyjt
		db	 9,'findfirst  '
\FINDNEXT:	jsr	mdfyjt
		db	 8,'findnext   '
\MKDIR:		jsr	mdfyjt
		db	 5,'mkdir      '
RENAME:		jsr	mdfyjt
		db	 6,'rename     '
\RESET:		jsr	mdfyjt
		db	 5,'reset      '
\REWRITE:	jsr	mdfyjt
		db	 7,'rewrite    '
\RMDIR:		jsr	mdfyjt
		db	 5,'rmdir      '
\DISKFREE:	jsr	mdfyjt
		db	 8,'diskfree   '
GETFTIME:	jsr	mdfyjt
		db	 8,'getftime   '
SETFTIME:	jsr	mdfyjt
		db	 8,'setftime   '
\CHDIR:		jsr	mdfyjt
		db	 5,'chdir      '
\BLOCKREAD:	jsr	mdfyjt
		db	 9,'blockread  '
\BLOCKWRITE:	jsr	mdfyjt
		db	10,'blockwrite '
FILECOPY:	jsr	mdfyjt
		db	 8,'filecopy   '
FILEMOVE:	jsr	mdfyjt
		db	 8,'filemove   '
READ_SECTOR:	jsr	mdfyjt
		db	11,'read_sector'
WRITE_SECTOR:	jsr	mdfyjt
		db	11,'write_secto'
DOSINI:		jsr	mdfyjt
		db	 6,'dosini     '
VALIDFD:	jsr	mdfyjt
		db	 7,'validfd    '
CFORMAT:	jsr	mdfyjt
		db	 7,'cformat    '
GET_FNDTBL:	jsr	mdfyjt
		db	10,'get_fndtbl '
SECTSIZ:	jsr	mdfyjt
		db	 7,'sectsiz    '
SELECTDISK:	jsr	mdfyjt
		db	10,'selectdisk '
GETPATH:	jsr	mdfyjt
		db	 7,'getpath    '
EXEC:		jsr	mdfyjt
		db	 4,'exec       '
;
;-----------------------------------
;  LCD
;-----------------------------------
lcdini:		jsr	mdfyjt
		db	 6,'lcdini     '
gotox:		jsr	mdfyjt
		db	 5,'gotox      '
;
;-----------------------------------
;  AUX
;-----------------------------------
sci0ini:	jsr	mdfyjt
		db	 7,'sci0ini    '
flushaux0:	jsr	mdfyjt
		db	 9,'flushaux0  '
sci1ini:	jsr	mdfyjt
		db	 7,'sci1ini    '
flushaux1:	jsr	mdfyjt
		db	 9,'flushaux1  '
;
;-----------------------------------
;  MTOS
;-----------------------------------
wait:		jsr	mdfyjt
		db	 4,'wait       '
pop:		jsr	mdfyjt
		db	 3,'pop        '
vop:		jsr	mdfyjt
		db	 3,'vop        '
taskrun:	jsr	mdfyjt
		db	 7,'taskrun    '
;
;-----------------------------------
;  MISC
;-----------------------------------
denorm:		jsr	mdfyjt
		db	 6,'denorm     '
llmld:		jsr	mdfyjt
		db	 5,'llmld      '
norm:		jsr	mdfyjt
		db	 4,'norm       '
bitdata:	jsr	mdfyjt
		db	 7,'bitdata    '
limitter:	jsr	mdfyjt
		db	 8,'limitter   '
upcase_string:	jsr	mdfyjt
		db	11,'upcase_strg'
getsw:		jsr	mdfyjt
		db	5,'getsw       '
;
	end