;
;======================================
;===                                ===
;===                                ===
;===  RUNTIME ROUTINE  by @  (1/2)  ===
;===   may 1 '93  (rtr1.asm)        ===
;===  for H8PAS ver 3.3             ===
;===                                ===
;======================================
;*
;* july  9 '96...for h8spas ver1.0
;* dec   3 '97...RTR0.ASM append
;*               RTRENT modified
;* mar 15 2000...RTRENT modified to $38000
;* nov  6 '01 ...READLN,RLNLST,ICH modified
;* jun 17 '03 ...MESS modified, RTR2 not use
;* jul  7 '03 ...TITLES,GUIDE
;* jul 10 '03 ...norm(x,y,z) & denorm(x,y)
;* aug 11 '03 ...llmld bugfix
;* sep  1 '03 ...rename(f,nam)
;* dec  4 '03 ...dldiv(xx,y) modified
;* mar  5 '04 ...llmld +/-$7fffffff limitter
;* --------------------------------------
;* feb. 7 '05 ...i/o routine sepc changed
;*               proc xx(var src: device; ch: char) for out
;*               func xx(var src: device): byte; for input
;* --------------------------------------
;* mar.16 '07 ...xeqys,etc modified
;*
;
;=================================
;==                             ==
;==  data table                 ==
;==                             ==
;=================================
;
;/	org	($+1)/2*2
;/;pi:	dw	h'8249,h'0fda,h'a221 ; pi
;/;
;/max:	dw	h'fb70,h'bdc2,h'1ab0 ; e+37
;/	dw	h'f840,h'97ce,h'7bc0 ; e+36
;/	dw	h'f51a,h'130b,h'9634 ; e+35
;/	dw	h'f176,h'84df,h'56b9 ; e+34
;/	dw	h'ee45,h'3719,h'122e ; e+33
;/	dw	h'eb1d,h'c5ad,h'a825 ; e+32
;/	dw	h'e77c,h'6f7c,h'403c ; e+31
;/	dw	h'e449,h'f2c9,h'ccfe ; e+30
;/	dw	h'e121,h'8f07,h'd732 ; e+29
;/	dw	h'de01,h'3f39,h'78f5 ; e+28
;/	dw	h'da4e,h'cb8f,h'27f0 ; e+27
;/	dw	h'd725,h'6fa5,h'b98c ; e+26
;/	dw	h'd404,h'5951,h'613d ; e+25
;/	dw	h'd053,h'c21b,h'cec9 ; e+24
;/	dw	h'cd29,h'6816,h'3f08 ; e+23
;/	dw	h'ca07,h'8678,h'326c ; e+22
;/	dw	h'c658,h'd726,h'b714 ; e+21
;/	dw	h'c32d,h'78eb,h'c5aa ; e+20
;/	dw	h'c00a,h'c723,h'0488 ; e+19
;/	dw	h'bc5e,h'0b6b,h'3a74 ; e+18
;/	dw	h'b931,h'a2bc,h'2ec4 ; e+17
;/	dw	h'b60e,h'1bc9,h'bf04 ; e+16
;/	dw	h'b263,h'5fa9,h'31a0 ; e+15
;/	dw	h'af35,h'e620,h'f480 ; e+14
;/	dw	h'ac11,h'84e7,h'2a00 ; e+13
;/	dw	h'a868,h'd4a5,h'1000 ; e+12
;/	dw	h'a53a,h'43b7,h'4000 ; e+11
;/	dw	h'a215,h'02f9,h'0000 ; e+10
;/	dw	h'9e6e,h'6b28,h'0000 ; e+09
;/	dw	h'9b3e,h'bc20,h'0000 ; e+08
;/	dw	h'9818,h'9680,h'0000 ; e+07
;/	dw	h'9474,h'2400,h'0000 ; e+06
;/	dw	h'9143,h'5000,h'0000 ; e+05
;/	dw	h'8e1c,h'4000,h'0000 ; e+04
;/	dw	h'8a7a,h'0000,h'0000 ; e+03
;/	dw	h'8748,h'0000,h'0000 ; e+02
;/	dw	h'8420,h'0000,h'0000 ; e+01
;/one:	dw	h'8100,h'0000,h'0000 ; e 00
;/	dw	h'7d4c,h'cccc,h'cccc ; e-01
;/	dw	h'7a23,h'd70a,h'3d70 ; e-02
;/	dw	h'7703,h'126e,h'978d ; e-03
;/	dw	h'7351,h'b717,h'58e2 ; e-04
;/	dw	h'7027,h'c5ac,h'471b ; e-05
;/	dw	h'6d06,h'37bd,h'05af ; e-06
;/	dw	h'6956,h'bf94,h'd5e5 ; e-07
;/	dw	h'662b,h'cc77,h'1184 ; e-08
;/	dw	h'6309,h'705f,h'4136 ; e-09
;/	dw	h'5f5b,h'e6fe,h'cebd ; e-10
;/	dw	h'5c2f,h'ebff,h'0bcb ; e-11
;/	dw	h'590c,h'bccc,h'096f ; e-12
;/	dw	h'5561,h'2e13,h'424b ; e-13
;/	dw	h'5234,h'24dc,h'3509 ; e-14
;/	dw	h'4f10,h'1d7c,h'f73a ; e-15
;/	dw	h'4b66,h'9594,h'bec4 ; e-16
;/	dw	h'4838,h'77aa,h'3236 ; e-17
;/	dw	h'4513,h'92ee,h'8e92 ; e-18
;/	dw	h'416c,h'1e4a,h'7db8 ; e-19
;/	dw	h'3e3c,h'e508,h'6492 ; e-20
;/	dw	h'3b17,h'1da0,h'5075 ; e-21
;/	dw	h'3771,h'c900,h'80bc ; e-22
;/	dw	h'3441,h'6d9a,h'0097 ; e-23
;/	dw	h'311a,h'be14,h'cd44 ; e-24
;/	dw	h'2d77,h'9687,h'aed4 ; e-25
;/	dw	h'2a46,h'1206,h'2576 ; e-26
;/	dw	h'271e,h'74d1,h'b791 ; e-27
;/	dw	h'237d,h'87b5,h'f282 ; e-28
;/	dw	h'204a,h'd2f7,h'f535 ; e-29
;/	dw	h'1d22,h'425f,h'f75e ; e-30
;/	dw	h'1a01,h'ceb3,h'2c4b ; e-31
;/	dw	h'164f,h'b11e,h'ad45 ; e-32
;/	dw	h'1326,h'274b,h'bdd2 ; e-33
;/	dw	h'1004,h'ec3c,h'97db ; e-34
;/	dw	h'0c54,h'ad2d,h'bfc5 ; e-35
;/	dw	h'092a,h'2424,h'9969 ; e-36
;/	dw	h'0608,h'1cea,h'1454 ; e-37
;/	dw	h'0259,h'c7dc,h'ed55 ; e-38
;
; copyright
;
	db 'Runtime routine for H8SPAS ver1.0'
	db "by @  july 9 '96"
;
;/	org	($+1)/2*2
;/sintbl:	dw h'7eaa,h'aaaa,h'aaaa ; -1/(2*3)
;/	dw h'7ccc,h'cccc,h'cccc ; -1/(4*5)
;/	dw h'7bc3,h'0c30,h'c30c ; -1/(6*7)
;/	dw h'7ae3,h'8e38,h'e38e ; -1/(8*9)
;/	dw h'7a94,h'f209,h'4f20 ; -1/(10*11)
;/	dw h'79d2,h'0d20,h'd20d ; -1/(12*13)
;/	dw h'799c,h'09c0,h'9c09 ; -1/(14*15)
;/	dw h'78f0,h'f0f0,h'f0f0 ; -1/(16*17)
;/	dw h'78bf,h'a02f,h'e80b ; -1/(18*19)
;/	dw h'789c,h'09c0,h'9c09 ; -1/(20*21)
;/	dw h'7881,h'848d,h'a8fa ; -1/(22*23)
;/;
;/dectbl:	dw	h'00e8,h'd4a5,h'1000 ; 1*e12.
;/	dw	h'0017,h'4876,h'e800 ; 1*e11.
;/	dw	h'0002,h'540b,h'e400 ; 1*e10.
;/	dw	h'0000,h'3b9a,h'ca00 ; 1*e09.
;/	dw	h'0000,h'05f5,h'e100 ; 1*e08.
;/	dw	h'0000,h'0098,h'9680 ; 1*e07.
;/	dw	h'0000,h'000f,h'4240 ; 1*e06.
;/	dw	h'0000,h'0001,h'86a0 ; 1*e05.
;/	dw	h'0000,h'0000,h'2710 ; 1*e04.
;/	dw	h'0000,h'0000,h'03e8 ; 1*e03.
;/	dw	h'0000,h'0000,h'0064 ; 1*e02.
;/	dw	h'0000,h'0000,h'000a ; 1*e01.
;
;=================================
;==  ( public )               * ==
;==  halt                       ==
;==                             ==
;=================================
;
halt:	nop
	bra	halt
;
;=================================
;==  ( public )                 ==
;==  exec                       ==
;==                             ==
;=================================
;*
;* proc exec(pc: pointer)
;*
exec:	mov.l	@sp+,r1		; get RET addr
	mov.l	@sp+,r0		; get terget
	mov.l	r1,@-sp		; save RET addr
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  static link set            ==
;==                             ==
;=================================
;*
;* in...r0.b = link count-1
;*      if r0.7=1 --> save PC,SP
;*
slset:	mov.l	@sp+,r2		; ret addr
	btst	#7,r0
	beq	$2		; not debug info save
	mov.l	r2,\ram		; PC save
	mov.l	sp,\ram+4	; SP save
	bclr	#7,r0
;
; fp set
;
$2:	mov.l	fp,r1		; src
	mov.l	fp,@-sp		
	mov.l	sp,fp
;
; slink copy
;
$1:	sub.l	#4,r1
	mov.l	@r1,r3
	mov.l	r3,@-sp
	dec.b	#1,r0
	bne	$1
	mov.l	fp,@-sp
;
; owari
;
	jmp	@r2
;
;=================================
;==  ( public )               * ==
;== link free cell for dispose  ==
;==                             ==
;=================================
;*
;* \ram+ 0...PC save {$d+ mode }
;* \ram+ 4...SP save {$d+ mode }
;* \ram+ 8...not used
;* \ram+12...1st level locacl work
;* \ram+16...ioresult work
;* \ram+18...doserror work
;* \ram+20...not used
;* \ram+24...not used
;* \ram+28...not used
;*
lnkfre:	mov.l	#\ram+h'0020,r1
	xor.l	r0,r0
	mov.l	r0,@-r1	; \ram+28
	mov.l	r0,@-r1	; \ram+24
	mov.l	r0,@-r1	; \ram+20
	mov.l	r0,@-r1	; \ram+16
	mov.l	r0,@-r1	; \ram+12
	mov.l	r0,@-r1	; \ram+8
	mov.l	r0,@-r1	; \ram+4
	mov.l	r0,@-r1	; \ram+0
;
; i/o device table copy
;
	mov.l	#\ram+h'0020,r1	; dest
	mov.l	#8,r3		; count
$1:	mov.l	#chout1,r0
	mov.l	r0,@r1		; out device
	add.l	#4,r1
	mov.l	#chin1,r0
	mov.l	r0,@r1		; inp device
	add.l	#4,r1
	dec.w	#1,r3
	bne	$1
;
; owari
;
	rts
;
;=================================
;==  ( public )               * ==
;==  idiv                       ==
;==                             ==
;=================================
;*
;* in...tos = longint ( Y )
;*      2nd = longint ( X )
;* out..r0.w = longint ( X div Y )
;*
idiv:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; X normalize
;
	xor.w	r2,r2		; +
	mov.l	@(12,fp),r0
	bpl	$1
	neg.l	r0
	mov.l	r0,@(12,fp)
	bnot	#0,r2		; -
;
; Y normalize
;
$1:	mov.l	@(8,fp),r0
	bpl	$2
	neg.l	r0
	mov.l	r0,@(8,fp)
	bnot	#0,r2
;
; if Y and $ffff0000<>0
;
$2:	and.l	#h'ffff0000,r0
	beq	$4
;
; Z:=0;
; while X>Y do begin
;   X:=X-Y; Z:=Z+1;
; end; {while}
;
	xor.l	r0,r0		; Z:=0
	mov.l	@(8,fp),r1	; Y
	mov.l	@(12,fp),r3	; X
$3:	sub.l	r1,r3		; X-Y
	ble	$5
	inc.l	#1,r0
	bra	$3
;
; hi(x) div y 
;
$4:	mov.w	@(10,fp),r1	; y
	mov.w	@(12,fp),r0	; hi
	extu.l	r0
	divxu.w	r1,r0
	mov.l	r0,@-sp
;
; lo(x) div y
;
	mov.w	@sp,r0		; amari
	mov.w	r0,@(12,fp)
	mov.l	@(12,fp),r0
	divxu.w	r1,r0
	mov.l	r0,@(12,fp)
;
; normalize
;
	mov.w	@(2,sp),r0	; hi(x) div y
	mov.w	r0,@(12,fp)
	mov.l	@(12,fp),r0	; x div y
$5:	mov.w	r2,r2
	beq	$6		; +
	neg.l	r0
;
; owari
;
$6:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2
	add.l	#8,sp
	mov.l	r0,r0		; Z flg set
	jmp	@r2
;
;=================================
;==  ( public )               * ==
;==  imod                       ==
;==                             ==
;=================================
;*
;* in...tos = integer ( Y )
;*      2nd = longint ( X )
;* out..r0.w = longint ( X mod Y )
;*
imod:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; normalize
;
	mov.l	@(10,fp),r0
	bpl	$1
	neg.l	r0
	mov.l	r0,@(10,fp)
;
; hi(x) div y 
;
$1:	mov.w	@(8,fp),r1	; y
	mov.w	@(10,fp),r0	; hi
	extu.l	r0
	divxu.w	r1,r0
	mov.l	r0,@-sp
;
; lo(x) div y
;
	mov.w	@sp,r0		; amari
	mov.w	r0,@(10,fp)
	mov.l	@(10,fp),r0
	divxu.w	r1,r0
	mov.l	r0,@(10,fp)
;
; amari
;
	mov.w	@(10,fp),r0	; amari
;	extu.l	r0
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1
	add.l	#6,sp
	extu.l	r0		; Z flg set
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  imul                       ==
;==                             ==
;=================================
;*
;* in...tos = longint ( Y )
;*      2nd = longint ( X )
;* out..r0.l = longint ( X * Y )
;*
imul:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; X normalize
;
	xor.b	r4,r4
	mov.l	@(12,fp),r0
	bpl	$1
	neg.l	r0
	mov.l	r0,@(12,fp)
	bnot	#0,r4		; sign -
;
; Y normalize
;
$1:	mov.l	@(8,fp),r0
	bpl	$2
	neg.l	r0
	mov.l	r0,@(8,fp)
	bnot	#0,r4		; sign -
;
; X*Y
;
$2:	mov.w	@(10,fp),r0
	mov.w	@(14,fp),r1
	mulxu.w	r1,r0
	mov.l	r0,@-sp		; 10.14
	mov.w	@(8,fp),r0
	mulxu.w	r1,r0		; 8.14
	mov.w	@sp,r1
	add.w	r1,r0
	mov.w	@(10,fp),r2
	mov.w	@(12,fp),r3
	mulxu.w	r3,r2		; 10.12
	add.w	r2,r0
	mov.w	r0,@sp		; 8.14+10.12
	mov.l	@sp+,r0		; X*Y result
;
; sign check
;
	mov.b	r4,r4
	beq	$3		; +
	neg.l	r0
;
; owari
;
$3:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1
	add.l	#8,sp
	mov.l	r0,r0		; Z flg set
	jmp	@r1
;
;=================================
;==                           * ==
;==  sqrt(abs(x))               ==
;==                             ==
;=================================
;*
;* in...tos.l = x ( +8 )
;* out..r0.l = sqrt(abs(x))
;*
absqrtl:mov.l	fp,@-sp
	mov.l	sp,fp
;
; S:=0;
; Y:=0;
; X:=abs(X);
;
	xor.l	r0,r0		; S
	mov.l	r0,r2		; Y
	mov.l	@(8,fp),r1	; X
	beq	$5		; X=0 now
	bpl	$1
	neg.l	r1
;
; Y <-- X ( 2bit )
;
$1:	mov.w	#16,r3		; loop count
$2:	shll.l	#1,r1
	rotxl.l	#1,r2
	shll.l	#1,r1
	rotxl.l	#1,r2
;
;  S:=2*S+1;
;  if Y>=S
;   then begin
;          Y:=Y-S;
;          S:=S+1;
;        end
;   else S:=S-1;
;
	shll.l	#1,r0
	inc.l	#1,r0		; S:=2*S+1
	cmp.l	r2,r0		; Y vs S
	bgt	$3		; S > Y
	sub.l	r0,r2
	inc.l	#1,r0		; S:=S+1
	bra	$4
$3:	bclr	#0,r0		; S:=S-1
$4:	dec.w	#1,r3
	bgt	$2		; next digit
	shlr.l	#1,r0		; sqrt(x)
;
; owari
;
$5:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1
	adds	#4,sp
	jmp	@r1
;
;=================================
;==                             ==
;==   SQRT(X*X+Y*Y+Z*Z)         ==
;==    full 32bit result        ==
;==                             ==
;=================================
;*
;*  in...tos.l = z
;*       2nd.l = y
;*       3rd.l = x
;*  out..r0.l = sqrt(x*x+y*y+z*z)
;*
\norm:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; sqr(x)
;
	mov.l	@(16,fp),r0	; X
	mov.l	r0,@-sp
	bsr	sqr
	mov.l	r0,@-sp		; lo of X*X
	mov.l	r1,@-sp		; hi of X*X
;
; sqr(y)
;
	mov.l	@(12,fp),r0	; Y
	mov.l	r0,@-sp
	bsr	sqr
	mov.l	r0,@-sp		; lo of Y*Y
	mov.l	r1,@-sp		; hi of Y*Y
;
; sqr(z)
;
	mov.l	@(8,fp),r0	; Z
	mov.l	r0,@-sp
	bsr	sqr
;
; sqr(x)+sqr(y)+sqr(z)
;
	mov.l	@sp+,r5		; hi of Y*Y
	mov.l	@sp+,r4		; lo of Y*Y
	add.l	r4,r0		; lo
	bcc	$1
	add.l	#1,r1
$1:	add.l	r5,r1		; hi
	mov.l	@sp+,r5		; hi of X*X
	mov.l	@sp+,r4		; lo of X*X
	add.l	r4,r0		; lo
	bcc	$2
	add.l	#1,r1
$2:	add.l	r5,r1		; hi
;
; sqrt(sqr(x)+sqr(y)+sqr(z))
;
	mov.l	r0,@-sp		; low
	mov.l	r1,@-sp		; hi
	bsr	sqrtdl
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1		; ret addr
	adds	#4,sp
	adds	#4,sp
	adds	#4,sp
	jmp	@r1
;
;=================================
;==                             ==
;==   SQRT(abs(X*X-Y*Y))        ==
;==    full 32bit result        ==
;==                             ==
;=================================
;*
;*  in...tos.l = y
;*       2nd.l = x
;*
;*  out..r0.l = sqrt(abs(x*x-y*y))
;*
\denorm:mov.l	fp,@-sp
	mov.l	sp,fp
;
; sqr(y)
;
	mov.l	@(8,fp),r0	; Y
	mov.l	r0,@-sp
	bsr	sqr
	mov.l	r0,@-sp		; lo of Y*Y
	mov.l	r1,@-sp		; hi of Y*Y
;
; sqr(x)
;
	mov.l	@(12,fp),r0	; X
	mov.l	r0,@-sp
	bsr	sqr		; r0=low, r1=hi
;
; sqr(x)-sqr(y)
;
	mov.l	@sp+,r5		; hi of Y*Y
	mov.l	@sp+,r4		; lo of Y*Y
	sub.l	r4,r0		; lo
	bcc	$1
	sub.l	#1,r1
$1:	sub.l	r5,r1
	bpl	$2
;
; abs(sqr(x)-sqr(y))
;
	not.l	r1		; hi
	not.l	r0		; low
	add.l	#1,r0
	bcc	$2
	add.l	#1,r1
;
; sqrt(abs(sqr(x)-sqr(y)))
;
$2:	mov.l	r0,@-sp		; low
	mov.l	r1,@-sp		; hi
	bsr	sqrtdl
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1		; ret addr
	adds	#4,sp
	adds	#4,sp
	jmp	@r1
;
;=================================
;==                           * ==
;==  sqr(x)                     ==
;==                             ==
;=================================
;*
;* in...tos.l = x ( +8 )
;* out..r1.l = hi of x*x
;*      r0.l = lo of x*x
;*
sqr:	mov.l	fp,@-sp
	mov.l	sp,fp
	subs	#4,sp
;
; x normalize
;
	mov.l	@(8,fp),r0
	bpl	$2
	neg.l	r0
	mov.l	r0,@(8,fp)
;
; x*x
;
$2:	mov.w	@(8,fp),r1	; H
	mov.w	@(10,fp),r5	; L
	mov.w	r1,r0
	mulxu.w	r1,r1		; H*H
	mulxu.w	r5,r0		; H*L
	shll.l	#1,r0		; 2*H*L
	bcc	$1
	add.l	#h'00010000,r1
$1:	mov.l	r0,@(-4,fp)
	mov.l	@(-2,fp),r0
	xor.w	r0,r0
	mulxu.w	r5,r5		; L*L
	add.l	r5,r0		; low
	bcc	$3
	add.l	#1,r1
$3:	mov.l	@(-6,fp),r4
	extu.l	r4
	add.l	r4,r1		; hi
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2
	adds	#4,sp
	jmp	@r2
;
;=================================
;==                           * ==
;==  sqrt(abs(x))               ==
;==  64bit to 32bit             ==
;==                             ==
;=================================
;*
;* func sqrtdl(l,h: longint): longint;
;*
;* in...tos.l = x high ( +8 )
;*      2nd.l = x low  ( +12 )
;* out..r0.l = sqrt(x)
;*
sqrtdl:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; S:=0;
; Y:=0;
; X:=abs(X);
;
	xor.l	r0,r0		; S
	mov.l	r0,r2		; Y
	mov.l	@(8,fp),r5	; Xh
	mov.l	@(12,fp),r4	; Xl
;
; Y <-- Xh,Xl ( 2bit )
;
	mov.w	#32,r3		; loop count
$2:	shll.l	#1,r4		; Xl
	rotxl.l	#1,r5		; Xh
	rotxl.l	#1,r2		; Y
	shll.l	#1,r4		; Xl
	rotxl.l	#1,r5		; Xh
	rotxl.l	#1,r2		; Y
;
;  S:=2*S+1;
;  if Y>=S
;   then begin
;          Y:=Y-S;
;          S:=S+1;
;        end
;   else S:=S-1;
;
	shll.l	#1,r0
	inc.l	#1,r0		; S:=2*S+1
	cmp.l	r2,r0		; Y vs S
	bgt	$3		; S > Y
	sub.l	r0,r2
	inc.l	#1,r0		; S:=S+1
	bra	$4
$3:	bclr	#0,r0		; S:=S-1
$4:	dec.w	#1,r3
	bgt	$2		; next digit
	shlr.l	#1,r0		; sqrt(x)
;
; owari
;
$5:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1
	adds	#4,sp
	adds	#4,sp
	jmp	@r1
;
;=======================================
;===                                 ===
;===  long*long/long --> long        ===
;===   mar 13 '03                    ===
;===                                 ===
;=======================================
;*
;*  in...tos.l = Z
;*       2nd.l = Y
;*       3rd.l = X
;*  out..R0.l  = X*Y/Z
;*
\llmld:	mov.l	fp,@-sp
	mov.l	sp,fp
	sub.l	#2,sp
;
; result sign get
;
	xor.w	r2,r2		; sign +
	mov.l	@(16,fp),r1	; X
	mov.l	@(12,fp),r0	; Y
	xor.l	r0,r1
	mov.l	@(8,fp),r0	; Z
	xor.l	r0,r1
	shll.l	#1,r1
	bcc	$1
	inc.w	#1,r2		; sign -
$1:	mov.w	r2,@(-2,fp)
;
; normalize X,Y,Z
;
	mov.l	@(16,fp),r0	; X
	bpl	$2
	neg.l	r0
$2:	mov.l	@(12,fp),r1	; Y
	bpl	$3
	neg.l	r1
$3:	mov.l	@(8,fp),r2	; Z
	bpl	$4
	neg.l	r2
	mov.l	r2,@(8,fp)
;
; X*Y
;
$4:	mov.l	r0,@-sp		; X
	mov.l	r1,@-sp		; Y
	bsr	\llmul		; R1.L+R0.L
;
; X*Y/Z
;
	mov.l	r0,@-sp		; lo of X*Y
	mov.l	r1,@-sp		; hi of X*Y
	mov.l	@(8,fp),r2	; Z
	mov.l	r2,@-sp
	bsr	\dldiv		; R1.L R0.L
;
; if +over flow
;  then set +maxvalue
;
	and.l	r1,r1
	bne	$6		; over flow !
	mov.l	r0,r2
	and.l	#h'80000000,r2
	beq	$7		; not over flow
$6:	xor.l	r1,r1
	mov.l	#h'7fffffff,r0	; +max value
;
; sign set
;
$7:	mov.w	@(-2,fp),r2	; sign
	beq	$5		; +
	not.l	r0
	not.l	r1
	add.l	#1,r0
	bcc	$5
	add.l	#1,r1
;
; owari
;
$5:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2
	add.l	#12,sp
	jmp	@r2
;
;==================================
;==                              ==
;==  long * long --> dlong       ==
;==                              ==
;==================================
;*
;* in...tos  = Y long ( Y >= 0 )
;*      2nd  = X long ( X >= 0 )
;* out..r1.l = hi of dlong X*Y
;*      r0.l = lo of dlong X*Y
;*
\llmul:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; XL*YL
;
	mov.w	@(14,fp),r1	; xl
	mov.w	@(10,fp),r0	; yl
	mulxu.w	r0,r1
	mov.l	r1,@-sp		; xl*yl
;
; XH*YH
;
	mov.w	@(12,fp),r1	; xh
	mov.w	@(8,fp),r0	; yh
	mulxu.w	r0,r1
	mov.l	r1,@-sp		; xh*yh
;
; XL*YH
;
	mov.w	@(14,fp),r1	; xl
	mov.w	@(8,fp),r0	; yh
	mulxu.w	r0,r1
	mov.l	@(2,sp),r0
	add.l	r1,r0
	mov.l	r0,@(2,sp)
	bcc	$1
	mov.w	@sp,r0
	inc.w	#1,r0
	mov.w	r0,@sp
;
; XH*YL
;
$1:	mov.w	@(12,fp),r1	; xh
	mov.w	@(10,fp),r0	; yl
	mulxu.w	r0,r1
	mov.l	@(2,sp),r0
	add.l	r1,r0
	mov.l	r0,@(2,sp)
	bcc	$2
	mov.w	@sp,r0
	inc.w	#1,r0
	mov.w	r0,@sp
;
; get result into R1.l & R0.l
;
$2:	mov.l	@sp+,r1
	mov.l	@sp+,r0
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2		; ret addr
	add.l	#8,sp
	jmp	@r2
;
;==================================
;==                              ==
;==  dlong / long --> long       ==
;==                              ==
;==================================
;*
;* in...tos  = Y long         ( Y  >= 0 )
;*      2nd  = hi of dlong XX ( XX >= 0 )
;*      3rd  = lo of dlong XX
;* out..R1.l = hi of dlong XX/Y
;*      R0.l = lo of dlong XX/Y
;*
\dldiv:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; result initialize
;
	xor.l	r0,r0
	xor.l	r1,r1
;
; xx=0 check
;
	mov.l	@(12,fp),r3	; xh
	mov.l	@(16,fp),r2	; xl
	mov.l	r3,r5
	or.l	r2,r5
	beq	$5		; xx=0 !
;
; Xh.l & Xl.l normalize ( set MSB=1 )
;
	mov.l	#32,r5		; shift count
$1:	dec.w	#1,r5
	shll.l	#1,r2
	rotxl.l	#1,r3
	bpl	$1
;
; Y=0 --> Y=1
;
	mov.l	@(8,fp),r4
	bne	$2
	mov.l	#1,r4		; assume y=1
;
; Y.l normalize ( set MSB=01 )
;
$2:	inc.w	#1,r5
	shll.l	#1,r4		; Y.l
	bpl	$2
	dec.w	#1,r5
	shlr.l	#1,r4
;
; digit check
;
	cmp.w	#0,r5
	blt	$5		; dig(xx)<dig(y) !
;
;-------------------------------
; XX div Y execute
;-------------------------------
$3:	cmp.l	r4,r3
	bcs	$4		; R4>R3
;
; XX-Y --> XX
; R0+1 --> R0
;
	sub.l	r4,r3
	inc.l	#1,r0		; result lo R0.l
	bra	$3
;
; digit check
;
$4:	cmp.w	#0,r5
	beq	$5		; end
	dec.w	#1,r5
;
; R0,R1, R2,R3 shift left
;
	shll.l	#1,r0		; result lo
	rotxl.l	#1,r1		; result hi
	shll.l	#1,r2		; org lo
	rotxl.l	#1,r3		; org hi
	bra	$3
;
; owari
;
$5:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r5		; ret addr
	add.l	#12,sp
	jmp	@r5
;
;=================================
;==  ( public )               * ==
;==  upcase                     ==
;==                             ==
;=================================
;*
;* in...tos = char
;* out..r0.w = char
;*
upcase:	mov.l	@sp+,r1		; ret addr
	mov.w	@sp+,r0		; data
	extu.w	r0
	cmp.b	#'a',r0
	bcs	$1
	cmp.b	#'z',r0
	bhi	$1
	sub.w	#32,r0
$1:	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  load char                  ==
;==                             ==
;=================================
;*
;* in ..tos = char
;* out..tos = string[255]
;*
lodc:	mov.l	@sp+,r1		; ret addr
	mov.w	@sp+,r0		; char
	sub.l	#256,sp
	mov.b	#1,r2
	mov.b	r2,@sp
	mov.b	r0,@(1,sp)
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  load string immediate      ==
;==                             ==
;=================================
;*
;* out..tos = dst string[255]
;*
lodsi:	mov.l	@sp+,r1		; ret addr
	sub.l	#256,sp
	mov.l	sp,r2		; dst
	mov.b	@r1,r3		; length
	extu.w	r3
$1:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$1
;
; set even
;
	inc.l	#1,r1
	bclr	#0,r1
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  load string                ==
;==                             ==
;=================================
;*
;* in...tos = src addr
;* out..tos = dest string[255]
;*
lods:	mov.l	@sp+,r5		; ret addr
	mov.l	@sp+,r4		; src addr
	sub.l	#256,sp
	mov.l	sp,r2		; dst addr
	mov.b	@r4,r3		; count
	extu.w	r3
$1:	mov.b	@r4+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$1
	jmp	@r5
;
;=================================
;==  ( public )               * ==
;==  load string immediate      ==
;==                             ==
;=================================
;*
;* in...tos = string[n] area
;* out..tos = string[n]
;*
ldsil:	mov.l	@sp+,r1		; src addr
	mov.l	sp,r2		; dst addr
	mov.b	@r1,r3		; length
	extu.w	r3
$1:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$1
;
; set even
;
	inc.l	#1,r1
	bclr	#0,r1
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  load string with limit     ==
;==                             ==
;=================================
;*
;* in...tos = src addr
;*      2nd = limit size n
;* out..tos = string[n]
;*
lodsl:	mov.l	@sp+,r3		; ret addr
	mov.l	@sp+,r4		; src addr
	xor.l	r5,r5
	mov.w	@sp+,r5		; limit
	mov.w	r5,r1		; count
;
; dst addr get
;
	add.l	#2,r5
	bclr	#0,r5
	sub.l	r5,sp
	mov.l	sp,r2
;
; length check
;
	mov.b	@r4+,r0
	cmp.b	r0,r1
	bcc	$2
	mov.b	r1,r0
	bra	$2
;
; copy
;
$1:	mov.b	@r4+,r0
$2:	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r1
	bge	$1
;
; owari
;
	jmp	@r3
;
;=================================
;==  ( public )               * ==
;==  add char                   ==
;==                             ==
;=================================
;*
;* in...tos=char
;*      2nd=string[255]
;* out..tos=string[255]
;*
addc:	mov.l	@sp+,r0		; ret addr
	mov.w	@sp+,r1		; char
	xor.l	r2,r2
	mov.b	@sp,r2
	cmp.b	#255,r2
	beq	$1		; max !
	inc.b	#1,r2
	mov.b	r2,@sp
	add.l	sp,r2
	mov.b	r1,@r2
$1:	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  add string immediate       ==
;==                             ==
;=================================
;*
;* in...tos=string[255] ( X )
;* out..tos=string[255] ( X+immd )
;*
addsi:	mov.l	@sp,r4		; Y addr
	xor.l	r0,r0
	mov.b	@r4,r0		; leng(Y)
	add.l	r4,r0
	add.l	#2,r0
	bclr	#0,r0		; even addr
	mov.l	r0,@sp		; ret addr
	lea	@(4,sp),r2	; X addr
	bsr	addstr
	rts
;
;=================================
;==  ( public )               * ==
;==  add string                 ==
;==                             ==
;=================================
;*
;* in...tos = src addr    ( Y )
;*      2nd = string[255] ( X )
;* out..tos = string[255] ( X+Y )
;*
adds:	mov.l	@sp+,r5		; ret addr
	mov.l	@sp+,r4		; string Y
	mov.l	sp,r2		; string X
	mov.l	r5,@-sp		; ret addr
	bsr	addstr
	rts
;
;=================================
;==  ( public )               * ==
;==  add string with stack      ==
;==                             ==
;=================================
;*
;* in...tos = string255 ( Y )
;*      2nd = string255 ( X )
;* out..tos = string255 ( X+Y )
;*
addss:	lea	@(4,sp),r4	; string Y
	lea	@(256,r4),r2	; string X
	bsr	addstr
	mov.l	@sp+,r0		; ret addr
	add.l	#256,sp
	jmp	@r0
;
;=================================
;==  ( common )               * ==
;==  add string                 ==
;==                             ==
;=================================
;*
;* in...r2.w = string X addr
;*      r4.w = string Y addr
;* out..X:=X+Y
;*
;
; destination get
;
addstr:	mov.l	r2,r1
	xor.l	r0,r0
	mov.b	@r2+,r0		; leng(X)
	add.l	r0,r2		; R2=last of X
;
; new length get
;
	mov.b	@r4+,r3		; leng(Y)
	add.b	r3,r0		; leng(Y)+leng(X)
	bcc	$1		; 0..255
	mov.b	#255,r0		; new length
	mov.b	r0,r3
	mov.b	@r1,r5
	sub.b	r5,r3		; 255-leng(X)
$1:	extu.w	r3
	mov.b	r0,@r1		; X[0]
	bra	$3
;
; X+Y
;
$2:	mov.b	@r4+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
$3:	dec.w	#1,r3
	bge	$2
;
; owari
;
	rts
;
;=================================
;==  ( public )               * ==
;==  append char                ==
;==                             ==
;=================================
;*
;* in..@pc = limit size ( 1 byte )
;*     tos = char
;*     2nd = dest addr
;*
apdc:	mov.l	@sp+,r0		; ret addr
	mov.w	@sp+,r1		; char
	mov.l	@sp+,r2		; dst addr
	mov.b	@r0+,r3		; limit size
;
; limit check
;
	xor.l	r4,r4
	mov.b	@r2,r4		; length
	cmp.b	r4,r3
	beq	$1		; exit
;
; length+1 & char set
;
	add.b	#1,r4
	mov.b	r4,@r2		; length+1
	add.l	r4,r2
	mov.b	r1,@r2		; data set
;
; owari
;
$1:	inc.l	#1,r0
	bclr	#0,r0
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  append string immediate    ==
;==                             ==
;=================================
;*
;* in..tos = dest addr
;*
apdsi:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; append string
;
	mov.l	@(4,fp),r1	; src addr
	mov.l	@(8,fp),r2	; dst addr
	mov.b	@r1+,r5		; dst limit
	mov.b	@r2,r0		; dst length
	sub.b	r0,r5
	xor.l	r3,r3
	mov.b	r0,r3
	add.l	r2,r3
	add.l	#1,r3		; dst end addr
	mov.b	@r1+,r4		; src length
;
; append body
;
$1:	mov.b	@r1+,r0		; char
	cmp.b	#0,r5		; limit chk
	beq	$2
	mov.b	r0,@r3
	inc.l	#1,r3
;
; length +1
;
	mov.b	@r2,r0
	inc.b	#1,r0
	mov.b	r0,@r2
	add.b	#-1,r5
$2:	add.b	#-1,r4
	bne	$1
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	add.l	#8,sp
	inc.l	#1,r1
	bclr	#0,r1
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  save string                ==
;==                             ==
;=================================
;*
;* in...tos = dest addr
;*      2nd = dest limit size
;*      3rd = src string[255]
;*
saves:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; save string
;
	lea	@(14,fp),r1	; src addr
	mov.l	@(8,fp),r2	; dst addr
	mov.b	@(13,fp),r0	; limit
	mov.b	@r1,r3
	cmp.b	r3,r0
	bcc	$1
	mov.b	r0,@r1
$1:	mov.b	@r1,r3		; length
	extu.w	r3
$2:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$2
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r0		; ret addr
	add.l	#262,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  move string                ==
;==                             ==
;=================================
;*
;* in...tos = dest addr 
;*      2nd = sour addr
;*      3rd = limit siz
;*
movs:	mov.l	@sp+,r2		; ret addr
	mov.l	@sp+,r3		; dst addr
	mov.l	@sp+,r4		; src addr
	mov.w	@sp+,r5		; limit siz
	mov.b	@r4+,r0		; r0:=leng(src)
	cmp.b	r0,r5
	bls	$2		; limit > leng(src)
	mov.b	r0,r5		; r0:=limit
	bra	$2
$1:	mov.b	@r4+,r0
$2:	mov.b	r0,@r3
	inc.l	#1,r3
	dec.w	#1,r5
	bge	$1
	jmp	@r2
;
;=================================
;==  ( public )               * ==
;==  move string immediate      ==
;==                             ==
;=================================
;*
;* in...tos = dest addr
;*
movsi:	mov.l	@sp+,r1		; ret addr
	mov.l	@sp+,r2		; dst addr
	mov.b	@r1,r3
	extu.w	r3
$1:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$1
;
; set even
;
	inc.l	#1,r1
	bclr	#0,r1
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  integer to string          ==
;==                             ==
;=================================
;*
;* in...tos = longint
;* out..tos = string[255]
;*
str:	mov.l	@sp+,r4		; ret addr
	mov.l	@sp+,r5		; value
	sub.l	#256,sp
	mov.l	r5,@-sp
	mov.l	r4,@-sp
	mov.l	fp,@-sp
	mov.l	sp,fp
;
; +/- check
;
	lea	@(13,fp),r2	; result area
	mov.l	@(8,fp),r5	; longint
	bpl	$1
	mov.b	#'-',r0
	mov.b	r0,@r2
	inc.l	#1,r2
	neg.l	r5
;
; integer to string
;
$1:	mov.l	r2,r1		; top addr
	mov.l	#$10-4,r4
$2:	add.l	#4,r4
	mov.l	@r4,r0
	beq	$4		; end
	mov.b	#'0',r3		; bcd
$3:	inc.b	#1,r3
	sub.l	r0,r5
	bge	$3
        add.l	r0,r5		; recover
	dec.b	#1,r3		; count -1
	mov.b	r3,@r2
	inc.l	#1,r2
	bra	$2
;
; end mark set
;
$4:	mov.b	#0,r3
	mov.b	r3,@r2
;
; 0 supress
;
	mov.l	r1,r2		; top addr
$5:	mov.b	@r2+,r0
	cmp.b	#'0',r0
	beq	$5
	cmp.b	#0,r0
	bne	$7
	dec.l	#1,r2
$7:	dec.l	#1,r2
;
; copy to stack
;
$6:	mov.b	@r2+,r0
	mov.b	r0,@r1
	inc.l	#1,r1
	cmp.b	#0,r0
	bne	$6
;
; length set
;
	lea	@(14,fp),r0
	sub.l	r0,r1
	mov.b	r1,@(12,fp)
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r0		; ret addr
	add.l	#4,sp
	jmp	@r0
;
; data table
;
$10:	dl	1000000000
	dl	100000000
	dl	10000000
	dl	1000000
	dl	100000
	dl	10000
	dl	1000
	dl	100
	dl	10
	dl	1
	dl	0
;
;=================================
;==  ( public )               * ==
;==  string to integer          ==
;==                             ==
;=================================
;*
;* in...tos = src string[255]
;* out..r0.l = value
;*      r1.l = flag
;*
val:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; string to integer
;
	xor.l	r0,r0		; value
	mov.l	#1,r1		; flag
	lea	@(8,fp),r4
	mov.b	@r4+,r3		; length
	extu.w	r3
	beq	$2		; length=0 end
;
; '-' check
;
	mov.w	r0,@-sp		; +
	xor.l	r2,r2
	mov.b	@r4+,r2
	cmp.b	#'+',r2
	beq	$4
	cmp.b	#'-',r2
	bne	$3
	mov.w	#1,r5
	mov.w	r5,@sp		; -
	bra	$4
;
; 0..9 check
;
$1:	xor.l	r2,r2
	mov.b	@r4+,r2
$3:	cmp.b	#'9',r2
	bhi	$2		; end
	sub.w	#'0',r2
	bcs	$2
;
; r0*10+r2
;
	mov.l	r0,r5
	add.l	r0,r0
	add.l	r0,r0
	add.l	r5,r0
	add.l	r0,r0
	add.l	r2,r0
;
; position count +1
;
$4:	add.l	#1,r1
	dec.w	#1,r3
	bgt	$1
;
; +/- modify
;
	mov.w	@sp+,r2		; +/- flg
	beq	$5		; +
	neg.l	r0		; result
$5:	xor.l	r1,r1		; flag
;
; owari
;
$2:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2		; ret addr
	add.l	#256,sp
	jmp	@r2
;
;=================================
;==  ( public )               * ==
;==  string pos. find           ==
;==                             ==
;=================================
;*
;* in...tos = dst string[255]
;*      2nd = src string[255]
;* out..R0.l = position
;*
pos:	mov.l	fp,@-sp
	mov.l	sp,fp
	sub.l	#14,sp
;
; position find
;
	xor.l	r0,r0		; pos
	mov.l	r0,@(-14,fp)
	lea	@(8,fp),r5
	mov.l	r5,@(-4,fp)	; dst addr
	mov.b	@r5+,r4		; length
	add.l	#255,r5	
	mov.b	@r5+,r3	
	mov.w	r3,@(-10,fp)	; src size
	mov.l	r5,@(-8,fp)	; src top addr
	sub.b	r3,r4		; dst-src length
	bcs	$3		; src > dst !
;
; search
;
	extu.w	r4
	inc.w	#1,r4		; 1..
$1:	dec.w	#1,r4
	bmi	$3		; not found
	mov.l	@(-4,fp),r2
	inc.l	#1,r2
	mov.l	r2,@(-4,fp)	; dst addr
	mov.l	@(-8,fp),r1	; src top addr
	mov.w	@(-10,fp),r3	; src size
$2:	mov.b	@r1+,r5
	mov.b	@r2+,r0
	cmp.b	r0,r5
	bne	$1		; next dst addr
	dec.b	#1,r3
	bne	$2		; next src/dst addr
;
; position calc
;
	mov.l	@(-4,fp),r0
	lea	@(8,fp),r1
	sub.l	r1,r0
	mov.l	r0,@(-14,fp)
$3:	mov.l	@(-14,fp),r0
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r1		; ret addr
	add.l	#512,sp
	mov.l	r0,r0		; Z flg set
	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  get partial string         ==
;==                             ==
;=================================
;*
;* in...tos = length to get      { fp+8 }
;*      2nd = position to get    { fp+10 }
;*      3rd = source string[255] { fp+12 }
;*      4th = result string[255]
;* out..tos = result string[255]
;*
copy:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; paramater initialize
;
	xor.l	r0,r0
	mov.b	r0,@(8,fp)	; len and $00ff;
	mov.b	r0,@(10,fp)	; pos and $00ff;
	mov.b	r0,@(268,fp)	; result string
;
; SRC vs POS check
;
	mov.b	@(12,fp),r3	; src size
	extu.w	r3
	mov.w	@(10,fp),r0
	sub.w	r0,r3		; src vs pos
	blt	$4		; src < pos !
;
; (SRC-POS) vs LEN check
;
	add.w	#1,r3		; src-pos
	mov.w	@(8,fp),r0	; len
	cmp.w	r0,r3		; (src-pos) vs len
	bgt	$1		; (src-pos) > len
	mov.w	r3,@(8,fp)	; len modify
;
; position initialize
;
$1:	lea	@(12,fp),r1	; src addr
	xor.l	r0,r0
	mov.w	@(10,fp),r0	; pos
	add.l	r0,r1		; src+pos
	lea	@(269,fp),r2	; result addr
	mov.w	@(8,fp),r3	; len
	bra	$3
;
; copy body
;
$2:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
$3:	dec.w	#1,r3
	bge	$2
;
; length set
;
	lea	@(269,fp),r0
	sub.l	r0,r2
	mov.b	r2,@(268,fp)
;
; owari
;
$4:     mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r0
	add.l	#260,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  delete partial string      ==
;==                             ==
;=================================
;*
;* in...tos = size            { fp+8  }
;*      2nd = position        { fp+10 }
;*      3rd = addr of strg    { fp+12 }
;*
delete:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; delete
;
	xor.l	r0,r0
	mov.b	r0,@(8,fp)	; siz and $00ff
	mov.b	r0,@(10,fp)	; pos and $00ff
	mov.l	@(12,fp),r1
	mov.b	@r1,r3		; terget size
	mov.b	@(11,fp),r0	; pos
	sub.b	r0,r3		; tgt siz-pos
	bcs	$3		; tgt siz-pos<0 !
	mov.b	@(9,fp),r0	; del siz
	sub.b	r0,r3		; tgtsiz-pos-delsiz
	bcc	$1		; tgtsiz-pos-delsiz>=0
;
; length modify
;
	mov.b	@(11,fp),r0
	dec.b	#1,r0		; may 22 '96
	mov.b	r0,@r1
	bra	$3
;
; move up
;
$1:	extu.w	r3
	mov.b	@r1,r0		; tgt siz
	mov.b	@(9,fp),r4	; del siz
	sub.b	r4,r0		; tgt-del
	mov.b	r0,@r1		; new length
	xor.l	r2,r2
	mov.w	@(10,fp),r2	; pos
	add.l	r1,r2
	mov.l	r2,r1
	xor.l	r0,r0
	mov.w	@(8,fp),r0
	add.l	r0,r1
$2:	mov.b	@r1+,r0
	mov.b	r0,@r2
	inc.l	#1,r2
	dec.w	#1,r3
	bge	$2
;
; owari
;
$3:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r0
	add.l	#8,sp
	jmp	@r0
;
;=================================
;==  ( public )                 ==
;==  X = Y check string         ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xeqys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#2,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  X <> Y check string        ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xneys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#5,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  X < Y check string         ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xltys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#1,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  X <= Y check string        ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xleys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#3,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  X > Y check string         ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xgtys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#4,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )                 ==
;==  X >= Y check string        ==
;==                             ==
;=================================
;*
;* in...tos = string[255] Y
;*      2nd = string[255] X
;* out..status = result
;*
xgeys:	mov.l	@sp+,r1
	bsr	xcmpys
	and.w	#6,r0
	beq	$1
	mov.w	#1,r0		; true
$1:	jmp	@r1
;
;=================================
;==  ( public )               * ==
;==  compare string             ==
;==                             ==
;=================================
;*
;* in...tos = string[255]  Y
;*      2nd = string[255]  X
;*
;* out..r0.w = result
;*         bit0...X<Y
;*         bit1...X=Y
;*         bit2...X>Y
;*
xcmpys:	mov.l	fp,@-sp
	mov.l	sp,fp
	mov.l	r1,@-sp
;
; compare
;
	lea	@(8,fp),r2	; Y
	lea	@(264,fp),r1	; X
;
; set end mark of Y
;
	xor.l	r0,r0
	mov.b	@r2+,r0
	cmp.b	#255,r0
	beq	$1
	add.l	r2,r0
	xor.b	r3,r3
	mov.b	r3,@r0		; end mark
;
; set end mark of X
;
$1:	xor.l	r0,r0
	mov.b	@r1+,r0
	cmp.b	#255,r0
	beq	$2
	add.l	r1,r0
	mov.b	r3,@r0		; end mark
;
; compare X and Y
;
$2:	mov.w	#1,r0
	mov.w	#255-1,r4
$3:	mov.b	@r1+,r3
	mov.b	@r2+,r5
	cmp.b	r5,r3
	bcs	$7		; X<Y
	bne	$6		; X>Y
	cmp.b	#0,r3
	beq	$5		; end mark
	dec.w	#1,r4
	bge	$3
;
; status set
;
$5:	dec.w	#2,r0
$6:	add.w	#3,r0
;
; owari
;
$7:	mov.l	@sp+,r1
	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r2
	add.l	#512,sp
	jmp	@r2
;
;=================================
;==  ( public )               * ==
;==  write string with cr/lf    ==
;==                             ==
;=================================
;*
;* in...tos = device
;*      2nd = string[255]
;*
wrtlns:	xor.w	r0,r0
	mov.w	r0,\ram+16	; ioresult:=0
;
	mov.l	@(4,sp),r1	; device
	lea	@(8,sp),r4
	mov.b	@r4+,r2
	extu.w	r2		; length
	beq	$2		; null string
$1:	mov.b	@r4+,r0
	bsr	cout
	sub.w	#1,r2
	bgt	$1
$2:	mov.b	#h'0d,r0
	bsr	cout
	mov.b	#h'0a,r0
	bsr	cout
;
; owari
;
	mov.l	@sp+,r0
	add.l	#260,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  write string               ==
;==                             ==
;=================================
;*
;* in...tos = device
;*      2nd = string[255]
;*
writes:	xor.w	r0,r0
	mov.w	r0,\ram+16	; ioresult:=0
;
	mov.l	@(4,sp),r1	; device
	lea	@(8,sp),r4
	mov.b	@r4+,r2
	extu.w	r2		; length
	beq	$2		; null string
$1:	mov.b	@r4+,r0
	bsr	cout
	sub.w	#1,r2
	bgt	$1
;
; owari
;
$2:	mov.l	@sp+,r0
	add.l	#260,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  type 1 char with cr/lf     ==
;==                             ==
;=================================
;*
;* in...tos = device
;*      2nd = data
;*
wrtlnc:	xor.w	r0,r0
	mov.w	r0,\ram+16	; ioresult:=0
;
	mov.l	@(4,sp),r1	; device
	mov.w	@(8,sp),r0
	bsr	cout		; R0..data,R1..dev addr
	mov.b	#h'0d,r0
	bsr	cout
	mov.b	#h'0a,r0
	bsr	cout
;
; owari
;
	mov.l	@sp+,r0
	add.l	#6,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  cr/lf write                ==
;==                             ==
;=================================
;*
;* in...tos = dveice
;*
crlf:	xor.w	r0,r0
	mov.w	r0,\ram+16	; ioresult:=0
;
	mov.l	@(4,sp),r1	; device
	mov.b	#h'0d,r0
	bsr	cout
	mov.b	#h'0a,r0
	bsr	cout
;
; owari
;
	mov.l	@sp+,r0
	add.l	#4,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  string length adjust       ==
;==                             ==
;=================================
;*
;* in...tos = max length
;*      2nd = string[255]
;* out..tos = string[255]
;*
adjlng:	mov.l	fp,@-sp
	mov.l	sp,fp
;
; check limit > length
;
	xor.l	r4,r4
	mov.b	@(9,fp),r4	; limit
	mov.b	@(10,fp),r0
	cmp.b	r0,r4		; length
	bls	$4		; not modify
;
; move down string
;
	lea	@(10,fp),r1
	xor.l	r3,r3
	mov.b	@r1+,r3		; length
	mov.l	r1,r2		; save
	add.l	r3,r1		; src
	add.l	r4,r2		; dst
	bra	$2
$1:	dec.l	#1,r1
	mov.b	@r1,r0
	mov.b	r0,@-r2
$2:	sub.w	#1,r3
	bge	$1
;
; fill space
;
$3:	mov.b	#' ',r0
	mov.b	r0,@r1
	inc.l	#1,r1
	cmp.l	r1,r2
	bne	$3
	mov.b	r4,@(10,fp)	; new length
;
; owari
;
$4:	mov.l	fp,sp
	mov.l	@sp+,fp
	mov.l	@sp+,r0
	add.l	#2,sp
	jmp	@r0
;
;=================================
;==  ( public )               * ==
;==  read string                ==
;==                             ==
;=================================
;*
;* in...tos = device
;* out..tos = string255
;*
readln:	mov.l	@sp+,r0
	mov.l	@sp+,r1		; r1..device
	sub.l	#256,sp
	mov.l	r0,@-sp
	mov.l	fp,@-sp
	mov.l	sp,fp
;
; get char
;
	mov.w	#255-1,r3	; limit
	lea	@(9,fp),r2	; dst
	xor.w	r0,r0
	mov.b	r0,@(8,fp)	; length:=0
	bra	$5		; r0.w=0 1st char get
$1:	mov.w	#1,r0		; r0.w=1 2nd char get
$5:	bsr	cin		; r0.b = data
	cmp.b	#h'0d,r0	; cr
	beq	$1		; skip
	cmp.b	#h'1a,r0	; ^z
	beq	$4
	cmp.b	#h'0a,r0	; lf
	beq	$4
	cmp.b	#h'08,r0	; bs
	bne	$3		; normal ch
;
; bs in
;
	mov.b	@(8,fp),r0
	bne	$2		; length=0 ?
	mov.b	#h'07,r0	; bell
	bsr	cout
	bra	$1
;
; bs exec
;
$2:	mov.b	#h'08,r0	; bs
	bsr	cout
	mov.b	#' ',r0		; sp
	bsr	cout
	mov.b	#h'08,r0	; bs
	bsr	cout
	mov.b	@(8,fp),r0
	dec.b	#1,r0
	mov.b	r0,@(8,fp)	; length-1
	dec.l	#1,r2		; pos-1
	inc.w	#1,r3		; limit+1
	bra	$1
;
; char in
;
$3:	mov.b	r0,@r2		; save
	inc.l	#1,r2		; ptr+1
	bsr	cout		; echo back
	mov.b	@(8,fp),r0
	inc.b	#1,r0
	mov.b	r0,@(8,fp)	; length+1
	dec.w	#1,r3
	bge	$1		; more
$4:	mov.b	#h'0d,r0	; cr
	bsr	cout
	mov.b	#h'0a,r0	; lf
	bsr	cout
;
; owari
;
	mov.l	fp,sp
	mov.l	@sp+,fp
	rts
;
;=================================
;==  ( public )               * ==
;==  read string with no echo   ==
;==                             ==
;=================================
;*
;* in...tos = device
;* out..tos = string255
;*
rlnlst:	mov.l	@sp+,r0		; ret
	mov.l	@sp+,r1		; device
	sub.l	#256,sp
	mov.l	r0,@-sp
	mov.l	fp,@-sp
	mov.l	sp,fp
;
; ioresult:=0
;
	xor.w	r0,r0
	mov.w	r0,\ram+16	; ioresult:=0
;
; get char
;
$4:	mov.w	#255-1,r3	; limit
	lea	@(9,fp),r2	; dst
	xor.w	r0,r0
	mov.b	r0,@(8,fp)	; length:=0
	bra	$6		; r0.w=0 1st char get
$1:	mov.w	#1,r0		; r0.w=1 2nd char get
$6:	bsr	cin		; r0.b = data
	cmp.b	#h'0d,r0	; cr
	beq	$1		; skip
	cmp.b	#h'1a,r0	; ^z
	beq	$3
	cmp.b	#h'0a,r0	; lf
	beq	$3
;
; char save
;
	mov.b	r0,@r2		; save
	inc.l	#1,r2		; ptr+1
	mov.b	@(8,fp),r0
	inc.b	#1,r0
	mov.b	r0,@(8,fp)	; length+1
	dec.w	#1,r3		; limit-1
	bge	$1		; more
;
; ioresult check
;
$2:	mov.w	\ram+16,r1
	bne	$3		; error
;
; ioresult:=1;
;
	mov.w	#1,r0
	mov.w	r0,\ram+16	; ioresult:=1
	bra	$4		; retry
;
; owari
;
$3:	mov.l	fp,sp
	mov.l	@sp+,fp
	rts
;
;=================================
;==  ( public )               * ==
;==  type 1 char                ==
;==                             ==
;=================================
;*
;* in...tos = device
;*      2nd = data
;*
tch:	mov.l	@(4,sp),r1	; device
	mov.l	@r1,r1		; out rou addr
	jmp	@r1		; goto out rou
;
;=================================
;==  ( public )               * ==
;==  get 1 char                 ==
;==                             ==
;=================================
;*
;* in...tos = device
;* out..r0.b = data
;*
ich:	mov.l	@(4,sp),r1	; device addr
	mov.l	@(4,r1),r1	; input rou addr
	jmp	@r1		; goto input rou.
;
;=================================
;==  ( common )                 ==
;==  ch out                     ==
;==                             ==
;=================================
;*
;* in...r0.b = data
;*      r1.l = device
;*
cout:	mov.l	r0,@-sp
	mov.l	r1,@-sp
	mov.l	r2,@-sp
	mov.l	r3,@-sp
	mov.l	r4,@-sp
	mov.l	r5,@-sp
;
; out data
;
	mov.w	r0,@-sp		; data
	mov.l	r1,@-sp		; device
	mov.l	@r1,r2		; out rou
	jsr	@r2
;
; owari
;
	mov.l	@sp+,r5
	mov.l	@sp+,r4
	mov.l	@sp+,r3
	mov.l	@sp+,r2
	mov.l	@sp+,r1
	mov.l	@sp+,r0
	rts
;
;=================================
;==  ( common )                 ==
;==  ch in                      ==
;==                             ==
;=================================
;*
;* in...r1.l = device
;* out..r0.b = data
;*
cin:	mov.l	r1,@-sp
	mov.l	r2,@-sp
	mov.l	r3,@-sp
	mov.l	r4,@-sp
	mov.l	r5,@-sp
;
; get char
;
	mov.l	r1,@-sp		; device
	mov.l	@(4,r1),r2	; inp rou
	jsr	@r2
;
; owari
;
	mov.l	@sp+,r5
	mov.l	@sp+,r4
	mov.l	@sp+,r3
	mov.l	@sp+,r2
	mov.l	@sp+,r1
	rts
;
	end
