;
;======================================
;===                                ===
;===  vecter    ( rtrvect.asm )     ===
;===   aug. 6 '96  by @             ===
;===                                ===
;======================================
;*
;*  july 16 '08 ... SDCD/B0* for RTR
;*  july 19 '08 ... SDCD/A0A
;*
;--------------------------------
; vector for H8/3052
;--------------------------------
\vect:	dl	powon		; power on entry
	dl	jtbl+4*01	; reserved
	dl	jtbl+4*02	; reserved
	dl	jtbl+4*03	; reserved
	dl	jtbl+4*04	; reserved
	dl	jtbl+4*05	; reserved
	dl	jtbl+4*06	; reserved
	dl	jtbl+4*07	; nmi
	dl	jtbl+4*08	; trapa #0
	dl	jtbl+4*09	; trapa #1
	dl	jtbl+4*10	; trapa #2
	dl	jtbl+4*11	; trapa #3
	dl	jtbl+4*12	; irq0
	dl	jtbl+4*13	; irq1
	dl	jtbl+4*14	; irq2
	dl	jtbl+4*15	; irq3
	dl	jtbl+4*16	; irq4
	dl	jtbl+4*17	; irq5
	dl	jtbl+4*18	; reserved
	dl	jtbl+4*19	; reserved
	dl	jtbl+4*20	; wovi
	dl	jtbl+4*21	; cmi
	dl	jtbl+4*22	; reserved
	dl	jtbl+4*23	; reserved
	dl	jtbl+4*24	; imia0
	dl	jtbl+4*25	; imib0
	dl	jtbl+4*26	; ovi0
	dl	jtbl+4*27	; reserved
	dl	jtbl+4*28	; imia1
	dl	jtbl+4*29	; imib1
	dl	jtbl+4*30	; ovi1
	dl	jtbl+4*31	; reserved
	dl	jtbl+4*32	; imia2
	dl	jtbl+4*33	; imib2
	dl	jtbl+4*34	; ovi2
	dl	jtbl+4*35	; reserved
	dl	jtbl+4*36	; imia3
	dl	jtbl+4*37	; imib3
	dl	jtbl+4*38	; ovi3
	dl	jtbl+4*39	; reserved
	dl	jtbl+4*40	; imia4 (debugger)
	dl	jtbl+4*41	; imib4
	dl	jtbl+4*42	; ovi4
	dl	jtbl+4*43	; reserved
	dl	jtbl+4*44	; den0a
	dl	jtbl+4*45	; den0b
	dl	jtbl+4*46	; den1a
	dl	jtbl+4*47	; den1b
	dl	jtbl+4*48	; reserved
	dl	jtbl+4*49	; reserved
	dl	jtbl+4*50	; reserved
	dl	jtbl+4*51	; reserved
	dl	jtbl+4*52	; eri0
	dl	jtbl+4*53	; rxi0
	dl	jtbl+4*54	; txi0
	dl	jtbl+4*55	; tei0
	dl	rxi1int		; eri1
	dl	rxi1int		; rxi1
	dl	jtbl+4*58	; txi1
	dl	jtbl+4*59	; tei1
	dl	jtbl+4*60	; adi
;
;=================================
;==                             ==
;==   jump table                ==
;==                             ==
;=================================
;
jtbl:	jsr	goapint		; power on entry
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; nmi
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; irq0
	jsr	goapint		; irq1
	jsr	goapint		; irq2
	jsr	goapint		; irq3
	jsr	goapint		; irq4
	jsr	goapint		; irq5
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; wovi
	jsr	goapint		; cmi
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; imia0
	jsr	goapint		; imib0
	jsr	goapint		; ovi0
	jsr	goapint		; reserved
	jsr	goapint		; imia1
	jsr	goapint		; imib1
	jsr	goapint		; ovi1
	jsr	goapint		; reserved
	jsr	goapint		; imia2
	jsr	goapint		; imib2
	jsr	goapint		; ovi2
	jsr	goapint		; reserved
	jsr	goapint		; imia3
	jsr	goapint		; imib3
	jsr	goapint		; ovi3
	jsr	goapint		; reserved
	jsr	goapint		; imia4
	jsr	goapint		; imib4
	jsr	goapint		; ovi4
	jsr	goapint		; reserved
	jsr	goapint		; den0a
	jsr	goapint		; den0b
	jsr	goapint		; den1a
	jsr	goapint		; den1b
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; reserved
	jsr	goapint		; eri0
	jsr	goapint		; rxi0
	jsr	goapint		; txi0
	jsr	goapint		; tei0
	jsr	goapint		; eri1
	jsr	goapint		; rxi1
	jsr	goapint		; txi1
	jsr	goapint		; txi1
	jsr	goapint		; adi
;
;=================================
;==                             ==
;==  go apprication             ==
;==                             ==
;=================================
;
goapint:mov.l	r0,@-sp
	mov.l	@(4,sp),r0	; pc
	sub.l	#jtbl+4,r0
	mov.l	@(usrvct,r0),r0
	mov.l	r0,@(4,sp)
	mov.l	@sp+,r0
	rts
;
;=================================
;==                             ==
;==  power on entry             ==
;==                             ==
;=================================
;
powon:	mov.l	usrvct,r0
	jmp	@r0
;
	end
